

////////////////////////////////////////// DATABLOCKS


datablock AudioDescription(LongRange3d : AudioDefaultLooping3d)
{
   maxDistance = 500;
   referenceDistance = 25;
   volume = 0.5;
};

datablock AudioProfile(CVPIwail)
{
   filename    = "./sounds/wail.wav";
   description = LongRange3d;
   preload = true;
};
datablock AudioProfile(CVPIyelp		: CVPIwail)		{filename = "./sounds/yelp.wav";};
datablock AudioProfile(CVPIphaser	: CVPIwail)		{filename = "./sounds/phaser.wav";};
datablock AudioProfile(CVPIhorn		: CVPIwail)		{filename = "./sounds/horn.wav";};




////////////////////////////////////////// SERVER COMMANDS


function servercmdsetCVPISiren(%client, %siren, %skipcheck)		//Set a looping primary siren
{
	//Before we do anything, make sure the client isn't trying to change the siren too rapidly.
	if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
	
	if(!%skipcheck)
	{
		if(getSimTime() < %client.lastCVPIsoundTime + 250)
		return;	//Fewer than 250 milliseconds have passed since client sent a command. Ignore this one.
		
		if(%siren != %veh.sirenActive && %siren != 0)	//Turning the siren off doesn't count as a command
		{
			%client.lastCVPIsoundTime = getSimTime();
		}
	}
	//If the above check did not activate, we're good to continue.
	

	if(%veh.getDataBlock().getName() !$= "CVPIvehicle" || %pl.getMountNode() != 0 || %veh.sirenDisabled) return;

	if(%siren == %veh.sirenActive || %siren == 0)
	{
		%veh.stopAudio(0);
		%veh.sirenActive = 0;
	}
	else switch(%siren)
	{
		case 1:
			%veh.playAudio(0, CVPIwail);
			%veh.sirenActive = 1;
			
		case 2:
			%veh.playAudio(0, CVPIyelp);
			%veh.sirenActive = 2;
			
		case 3:
			%veh.playAudio(0, CVPIphaser);
			%veh.sirenActive = 3;
	}
}

function servercmdholdCVPIsound(%client, %toggle, %effect)		//Replace the siren temporarily
{
	//Before we do anything, make sure the client isn't trying to change the siren too rapidly.
	if(%toggle == 1)
	{
		if(getSimTime() < %client.lastCVPIsoundTime + 200)
			return;	//Fewer than 200 milliseconds have passed since client sent a command. Ignore this one.
			
		%client.lastCVPIsoundTime = getSimTime(); 	//Otherwise, right now is when they sent the last command.
	}	
	
	if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
	if(%veh.getDataBlock().getName() !$= "CVPIvehicle" || %pl.getMountNode() > 1) return;
	
	switch(%toggle)
	{
		case 0:		//Restore the siren, horn is done
			if(%veh.holding)
			{
				%veh.holding = 0;
				servercmdsetCVPISiren(%client, %veh.previousSiren, 1);
			}
			
		case 1:		//It's horn time.
		
			%veh.previousSiren = %veh.sirenActive;
			%veh.sirenActive = 4;
			%veh.holding = 1;
			
			switch(%effect)
			{
				case 0:
					%veh.playAudio(0, CVPIhorn);
				case 1:
					%veh.playAudio(0, CVPIwail);
				case 2:
					%veh.playAudio(0, CVPIyelp);
				case 3:
					%veh.playAudio(0, CVPIphaser);
			}
	}
}