datablock WheeledVehicleSpring(CVPISpring)
{
	length = 0.3;
	force = 3500;
	damping = 850;
	antiSwayForce = 0;
};

datablock WheeledVehicleTire(CVPITire)
{
	shapeFile = "./shapes/CVPItire.dts";
	
	mass = 10;
	radius = 1;
	staticFriction = 3;
	kineticFriction = 3;
	restitution = 0.5;	

	lateralForce = 3000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 14000;
	longitudinalDamping = 1400;
	longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleData(CVPIVehicle : CrownVictoriaVehicle)
{
	shapeFile = "./shapes/CVPI.dts";
  	uiName = "CV Police Interceptor";

	driverLightsCompatible = 0;

	engineTorque = 4200;
	maxWheelSpeed = 70;

	defaultTire = CVPITire;
	defaultSpring = CVPISpring;
};

datablock ShapeBaseImageData(CVPIspotlight)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 10;
   rotation = "1 0 0 -90";

	lighttype="constantlight";
	lightcolor="1 1 1";
	lightradius=300;

	stateName[0] = "Ready";

};

datablock ShapeBaseImageData(CVPIredlight)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 8;
   rotation = "1 0 0 -90";

	lighttype="pulsinglight";
	lightcolor="0.5 0.1 0";
	lightradius=100;
	lighttime=100;

	stateName[0] = "Ready";

};

datablock ShapeBaseImageData(CVPIbluelight)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 9;
   rotation = "1 0 0 -90";

	lighttype="pulsinglight";
	lightcolor="0 0.25 1";
	lightradius=100;
	lighttime=100;

	stateName[0] = "Ready";

};





package CVPIDriverLights
{

	function armor::onUnMount(%this, %obj, %col, %slot)
	{
		Parent::onUnMount(%this, %obj, %col, %slot);

		if (!isObject(%col) || %obj.getMountNode() != 0 || %col.getDatablock().getName() !$= "CVPIVehicle")
			return;

		%col.hasDriver = 0;	//To assist loopLights
		%col.stopAudio(0);
		%col.stopAudio(1);
		%col.sirenActive = 0;
		%col.holding = 0;
		%col.hidenode(signallights1);
		%col.hidenode(signallights1F);
		%col.unhidenode(signallights0);
		%col.hidenode(computer1);
		%col.unhidenode(computer0);
		if(%col.headlight)
		{
			%col.headlight = 0;
			%col.hidenode(headlightF);
			%col.hidenode(headlightindicator);
			if(!%col.spotlight)
			{
				%col.unmountimage(2);
				%col.unmountimage(3);
			}
		}

		if (!%col.lightPatternActive)		//Light pattern is off, so behave normally.
		{
			%col.hideNode(brake1);
			%col.hidenode(brake2);
			%col.hideNode(brake1nop);
			%col.hidenode(brake2nop);
			%col.hideNode(headlight1);
			%col.unhidenode(brake0);
			%col.unhideNode(headlight0);
		}					//If light pattern is active, do nothing here.
	}
	function armor::onMount(%this, %obj, %col, %slot)
	{
		Parent::onMount(%this, %obj, %col, %slot);
		
		if (!isObject(%col) || %obj.getMountNode() != 0 || %col.getDatablock().getName() !$= "CVPIVehicle")
			return;

		%col.hasDriver = 1;	//To assist loopLights until I know of a way for a car to see if it has a driver
		
		%col.unhidenode(signallights1);
		%col.hidenode(signallights0);
		%col.unhidenode(computer1);
		%col.hidenode(computer0);

		if (!%col.lightPatternActive)		//Light pattern is off, so behave normally.
		{
			%col.unhideNode(brake1);
			%col.unhidenode(brake2);
			%col.unhideNode(brake1nop);
			%col.unhidenode(brake2nop);
			%col.unhideNode(headlight1);
			%col.hidenode(brake0);
			%col.hideNode(headlight0);
		}					//If light pattern is active, do nothing here.
	}
};
activatePackage(CVPIDriverLights);