package CVPI_loopLights
{	
	function serverCmdCVPIcontrol(%client)
	{
		if(%client.CVPIcontrolDisabled)
		{
			%client.bottomPrint("ENABLED CVPI controls. Use your light, clicks, and brick shifts.", 8);
			%client.CVPIcontrolDisabled = 0;
		}
		else
		{
			%client.bottomPrint("DISABLED CVPI controls. The CVPI will not interrupt controls.", 8);
			%client.CVPIcontrolDisabled = 1;
		}
	}
	
	function serverCmdLight(%client)
	{
		if(!%client.CVPIcontrolDisabled && isObject(%pl = %client.player) && !isObject(%pl.light) && isObject(%veh = %pl.getObjectMount()))
		{
			if(%veh.getDataBlock().getName() $= "CVPIvehicle" && %pl.getMountNode() == 0)
			{
				servercmdloopCVPIlights(%client, 1, 6, 33);
				return;
			}
		}
		parent::serverCmdLight(%client);
	}
	
	function serverCmdShiftBrick(%client, %x, %y, %z)
	{
		if(!%client.CVPIcontrolDisabled && isObject(%pl = %client.player) && isObject(%veh = %pl.getObjectMount()))
		{
			if(%veh.getDataBlock().getName() $= "CVPIvehicle" && %pl.getMountNode() == 0)
			{
				if(%x == -1)								//Shift brick towards
					servercmdsetCVPISiren(%client, 0, 0);			//Siren: Off
					
				else if(%x == 1)							//Shift brick away
					servercmdsetCVPISiren(%client, 1, 0);			//Siren: Wail
					
				else if(%y == 1)							//Shift brick left
					servercmdsetCVPISiren(%client, 3, 0);			//Siren: Phaser
					
				else if(%y == -1)							//Shift brick right
					servercmdsetCVPISiren(%client, 2, 0);			//Siren: Yelp
					
				else if(%z == -3)							//Shift brick down
					servercmdtoggleCVPIspotlight(%client);		//Toggle spotlight
					
				else if(%z == 3)							//Shift brick up
					servercmdtoggleCVPIheadlight(%client);		//Toggle headlight
			}
		}
		parent::serverCmdShiftBrick(%client, %x, %y, %z);
	}
	
	function armor::onTrigger(%this, %obj, %slot, %val)		//Click while in the car to control the siren
 	{
		if(!%obj.client.CVPIcontrolDisabled && %obj.getClassName()$="Player" && %slot == 0 && %obj.isMounted() && %obj.currTool == -1)
		{	//If they have not turned off these controls, they are a player, they clicked, they're mounted to something, and they have no tool
			%client = %obj.client;			//assign these values to simplify this code
			%veh = %obj.getObjectMount();
			
			if(%veh.GetDatablock().getName() $= "CVPIVehicle" && %obj.getMountNode() == 0)
			{	//If the thing they're mounted to is our CVPIvehicle and they are the driver
				if(%val)	//If a player just clicked
				{
					%obj.lastTrigger = %veh.GetDatablock().schedule
						(150, CVPIonTriggerHold, %veh, %client);	//Now that the player has clicked, wait 150 ms and then call CVPIonTriggerHold
				}
				else	
				{											//Now the player has released the mouse
					cancel(%obj.lastTrigger);				//Cancel the schedule so that if CVPIonTriggerHold has not been called yet, it will not be called.
					if(%veh.holding == 1)					//If a horn is currently being held, implying that the mouse held down
					{
						%veh.holding = 0;					//This is the same pair of statements called with holdCVPIsiren when %toggle is 0
						servercmdsetCVPISiren(%client, %veh.previousSiren, 1);	//They are rewritten here so that redundant checks aren't used
					}
					else
					{
						if(!%veh.sirenActive)
							servercmdsetCVPISiren(%client, 1);	//Otherwise, switch
							
						else
							servercmdsetCVPISiren(%client, 0);
					}
				}
			}
		}
		return Parent::onTrigger(%this, %obj, %slot, %val);
	}
	
	function CVPIVehicle::CVPIonTriggerHold(%this, %obj, %client)		//CVPIvehicle datablock, the car in question, 1 or 0, the client responsible
	{
		if(getSimTime() < (%client.lastHornClick + 300))	//Do not allow this to be called too frequently
		{
			return;
		}
		else
		{
			%client.lastHornClick = getSimTime();
			
			if(%obj.sirenActive == 0 || %obj.sirenActive == 3)
				serverCmdholdCVPIsound(%client, 1, 0);	

			else
				serverCmdholdCVPIsound(%client, 1, %obj.sirenActive + 1);
		}
		return;
	}

	function servercmdtoggleCVPIspotlight(%client)
	{
		//Before we do anything, make sure the client isn't trying to change the light too rapidly.
		if(getSimTime() < %client.lastCVPIlightTime + 300)
		{
			return;	//Fewer than 300 milliseconds have passed since client sent a command. Ignore this one.
		}
		//If the above check did not activate, we're good to continue.
		%client.lastCVPIlightTime = getSimTime();	//Right now is when they sent the last command.	
		
		if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
		if(%veh.getDataBlock().getName() !$= "CVPIvehicle" || %pl.getMountNode() != 0) return;
		
		if(!%veh.spotlight)
		{
			%veh.spotlight = 1;
			%veh.mountImage(CVPIspotlight, 2);
			%veh.mountImage(CVPIspotlight, 3);
			%veh.unhidenode(spotlight1);
			%veh.unhidenode(spotlight1F);
			%veh.hidenode(spotlight0);
		}
		else
		{
			%veh.spotlight = 0;
			%veh.unMountImage(2);
			%veh.unMountImage(3);
			%veh.hidenode(spotlight1);
			%veh.hidenode(spotlight1F);
			%veh.unhidenode(spotlight0);
			if(%veh.headlight)				//The headlights are on, so reinstate their light
			{
				%veh.mountImage(CrownVicHL1, 2);
				%veh.mountImage(CrownVicHL2, 3);
			}
		}
	}

	function servercmdtoggleCVPIheadlight(%client)
	{
		//Before we do anything, make sure the client isn't trying to change the light too rapidly.
		if(getSimTime() < %client.lastCVPIlightTime + 300)
		{
			return;	//Fewer than 300 milliseconds have passed since client sent a command. Ignore this one.
		}
		//If the above check did not activate, we're good to continue.
		%client.lastCVPIlightTime = getSimTime();	//Right now is when they sent the last command.	
		
		if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
		if(%veh.getDataBlock().getName() !$= "CVPIvehicle" || %pl.getMountNode() != 0) return;
		
		if(!%veh.spotlight)		//The spotlight is not on, so we control the actual lights.
		{
			if(%veh.headlight)	//The headlight is already on, so we gotta turn it off
			{
				%veh.headlight = 0;
				%veh.hidenode(headlightindicator);
				%veh.hidenode(headlightF);
				%veh.unMountImage(2);
				%veh.unMountImage(3);
			}
			else				//Headlight's off, so let's turn it on.
			{
				%veh.headlight = 1;
				%veh.unhidenode(headlightindicator);
				%veh.mountImage(CrownVicHL1, 2);	//Hey, we're actually using datablocks from the stock Crown Vic for once!
				%veh.mountImage(CrownVicHL2, 3);
				%veh.unhidenode(headlightF);
			}
		}
		else	//The spotlight is on, so do not overwrite or unmount the brighter lights; change the visual and variable only.
		{
			if(%veh.headlight)		//Headlight was on, so off with it
			{
				%veh.headlight = 0;
				%veh.hidenode(headlightindicator);
				%veh.hidenode(headlightF);
			}
			else					//Headlight was off, but spotlight is on, so say the headlight's on and show the flares.
			{
				%veh.headlight = 1;
				%veh.unhidenode(headlightindicator);
				%veh.unhidenode(headlightF);
			}
		}
	}
	
	function servercmdloopCVPIlights(%client, %pattern, %count, %freq)
	{	
		//Before we do anything, make sure the client isn't trying to change the siren too rapidly.
		if(getSimTime() < %client.lastCVPIlightTime + 300)
		{
			return;	//Fewer than 300 milliseconds have passed since client sent a command. Ignore this one.
		}
		//If the above check did not activate, we're good to continue.
		%client.lastCVPIlightTime = getSimTime();	//Right now is when they sent the last command.	
		
		if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
		if(%veh.getDataBlock().getName() !$= "CVPIvehicle" || %pl.getMountNode() > 1) return;
		
		if(%veh.lightPatternActive == 0)
		{
			%veh.lightPatternActive = 1;
			CVPIVehicle.loopLights(%veh, %pattern, %count, %freq);
		}
		else
		{
			%veh.lightPatternActive = 0;
		}
	}
	
	
	function CVPIVehicle::loopLights(%this, %obj, %pattern, %count, %freq)
	{
		//%pattern:	[0-3] Argument to determine which light pattern we want to use
		//%count:	[1+ ] How long we want the pattern to run

		cancel(%obj.lastSchedule);	//Make sure it's not in the middle of activating lights
		if (!isObject(%obj)) return;	//If the car is gone, return. Do not pass Go. Do not collect $200.

		%obj.hidenode(headlight1);
		%obj.hidenode(brake1nop);
		%obj.hidenode(brake2nop);
		%obj.hidenode(headlight0);
		%obj.hidenode(brake0);

		%pattern = (%pattern $= "" ? 1 : %pattern);		//Default values
		%count = (%count $= "" ? 6 : %count);
		%freq = (%freq < 10 ? 25 : %freq);
		
		if(%obj.lightPatternActive == 0)		//Clear it up and schedule nothing. 
		{												//TO STOP LOOP: lightPatternActive = 0
			if (%obj.hasDriver)
			{
				%obj.unhidenode(headlight1);
				%obj.unhidenode(brake1nop);
				%obj.unhidenode(brake2nop);
			}
			else
			{
				%obj.unhidenode(headlight0);
				%obj.unhidenode(brake0);
			}
			
			%obj.unhideNode(nonbar0);
			%obj.unhideNode(barRed0);
			%obj.unhideNode(barBlue0);
			%obj.unMountImage(0);
			%obj.unMountImage(1);
			
			return;
		}
		
		if(%obj.lightPatternActive > 0)		//These lights occur with every pattern, so always schedule them
		{
			%obj.unhideNode(headlightp1);	%obj.unhideNode(headlightp1F);
			%obj.unhideNode(brakep1);
			%obj.mountImage(CVPIredlight,0);	%obj.mountImage(CVPIredlight,1);
			%obj.unhideNode(nonbar1);						%obj.unhideNode(nonbar1F);
			%obj.schedule(%freq*3, hidenode, nonbar1);		%obj.schedule(%freq*3, hidenode, nonbar1F);
			%obj.schedule(%freq*3, unhidenode, nonbar0);
			%obj.schedule(%freq*6, hidenode, nonbar0);
			%obj.schedule(%freq*6, unhidenode, nonbar1);	%obj.schedule(%freq*6, unhidenode, nonbar1F);
			%obj.schedule(%freq*10, hidenode, headlightp1);	%obj.schedule(%freq*10, hidenode, headlightp1F);
			%obj.schedule(%freq*10, hidenode, brakep1);
			%obj.schedule(%freq*10, unhidenode, headlightp2);	%obj.schedule(%freq*10, unhidenode, headlightp2F);
			%obj.schedule(%freq*10, unhidenode, brakep2);
			%obj.schedule(%freq*10, mountImage, CVPIbluelight, 0);	%obj.schedule(%freq*10, mountImage, CVPIbluelight, 1);
			%obj.schedule(%freq*10, hidenode, nonbar1);		%obj.schedule(%freq*10, hidenode, nonbar1F);
			%obj.schedule(%freq*10, unhidenode, nonbar2);	%obj.schedule(%freq*10, unhidenode, nonbar2F);
			%obj.schedule(%freq*13, hidenode, nonbar2);		%obj.schedule(%freq*13, hidenode, nonbar2F);
			%obj.schedule(%freq*13, unhidenode, nonbar0);
			%obj.schedule(%freq*16, hidenode, nonbar0);
			%obj.schedule(%freq*16, unhidenode, nonbar2);	%obj.schedule(%freq*16, unhidenode, nonbar2F);
			%obj.schedule(%freq*20, hidenode, headlightp2);	%obj.schedule(%freq*20, hidenode, headlightp2F);
			%obj.schedule(%freq*20, hidenode, brakep2);
			%obj.schedule(%freq*20, hidenode, nonbar2);		%obj.schedule(%freq*20, hidenode, nonbar2F);
		}

		switch(%pattern)
		{
			
			///////////////////////////////////////////////////////////////////////////////////////////////

			case 0:				//Turn off the lights
			//Oops, this is empty now.
			echo("CVPI_loopLights.cs: This should not happen. Returning.");
			return;

			///////////////////////////////////////////////////////////////////////////////////////////////

			case 1:

			%obj.lightPatternActive = 1;

			%obj.unhideNode(barRed1);	%obj.unhideNode(barRed1F);					//	R  XXX-===  B
			%obj.unhideNode(barBlue0);
			%obj.schedule(%freq*3, hidenode, barRed1);		%obj.schedule(%freq*3, hidenode, barRed1F);
			%obj.schedule(%freq*3, unhidenode, barRed0);
			%obj.schedule(%freq*6, hidenode, barRed0);
			%obj.schedule(%freq*6, unhidenode, barRed1);	%obj.schedule(%freq*6, unhidenode, barRed1F);
			%obj.schedule(%freq*10, hidenode, barRed1);		%obj.schedule(%freq*10, hidenode, barRed1F);
			%obj.schedule(%freq*10, hidenode, barBlue0);
		
			%obj.schedule(%freq*10, unhidenode, barRed0);	//	R  ===-XXX  B
			%obj.schedule(%freq*10, unhidenode, barBlue1);	%obj.schedule(%freq*10, unhidenode, barBlue1F);
			%obj.schedule(%freq*13, hidenode, barRed0);
			%obj.schedule(%freq*13, hidenode, barBlue1);	%obj.schedule(%freq*13, hidenode, barBlue1F);
			%obj.schedule(%freq*13, unhidenode, barBlue0);
			%obj.schedule(%freq*13, unhidenode, barRed0);
			%obj.schedule(%freq*16, hidenode, barBlue0);
			%obj.schedule(%freq*16, unhidenode, barRed0);
			%obj.schedule(%freq*16, unhidenode, barBlue1);	%obj.schedule(%freq*16, unhidenode, barBlue1F);
			%obj.schedule(%freq*20, hidenode, barRed0);
			%obj.schedule(%freq*20, hidenode, barBlue1);	%obj.schedule(%freq*20, hidenode, barBlue1F);
			
			///////////////////////////////////////////////////////////////////////////////////////////////
			
			case 2:

			%obj.lightPatternActive = 2;		
			
			%obj.unhideNode(barRed5);	%obj.unhideNode(barRed5F);					//	R  =XX-==X  B
			%obj.unhideNode(barBlue4);	%obj.unhideNode(barBlue4F);
			%obj.schedule(%freq*3, hidenode, barRed5);		%obj.schedule(%freq*3, hidenode, barRed5F);
			%obj.schedule(%freq*3, hidenode, barBlue4);		%obj.schedule(%freq*3, hidenode, barBlue4F);
			%obj.schedule(%freq*3, unhidenode, barRed0);
			%obj.schedule(%freq*3, unhidenode, barBlue0);
			%obj.schedule(%freq*6, unhidenode, barRed5);	%obj.schedule(%freq*6, unhidenode, barRed5F);
			%obj.schedule(%freq*6, unhidenode, barBlue4);	%obj.schedule(%freq*6, unhidenode, barBlue4F);
			%obj.schedule(%freq*6, hidenode, barRed0);
			%obj.schedule(%freq*6, hidenode, barBlue0);
			%obj.schedule(%freq*10, hidenode, barRed5);		%obj.schedule(%freq*10, hidenode, barRed5F);
			%obj.schedule(%freq*10, hidenode, barBlue4);	%obj.schedule(%freq*10, hidenode, barBlue4F);
			//SWITCH

			%obj.schedule(%freq*10, unhidenode, barRed4);	%obj.schedule(%freq*10, unhidenode, barRed4F);	//	R  X==-XX=  B
			%obj.schedule(%freq*10, unhidenode, barBlue5);	%obj.schedule(%freq*10, unhidenode, barBlue5F);
			%obj.schedule(%freq*13, hidenode, barRed4);		%obj.schedule(%freq*13, hidenode, barRed4F);
			%obj.schedule(%freq*13, hidenode, barBlue5);	%obj.schedule(%freq*13, hidenode, barBlue5F);
			%obj.schedule(%freq*13, unhidenode, barRed0);
			%obj.schedule(%freq*13, unhidenode, barBlue0);
			%obj.schedule(%freq*16, hidenode, barRed0);
			%obj.schedule(%freq*16, hidenode, barBlue0);
			%obj.schedule(%freq*16, unhidenode, barRed4);	%obj.schedule(%freq*16, unhidenode, barRed4F);
			%obj.schedule(%freq*16, unhidenode, barBlue5);	%obj.schedule(%freq*16, unhidenode, barBlue5F);
			%obj.schedule(%freq*20, hidenode, barRed4);		%obj.schedule(%freq*20, hidenode, barRed4F);
			%obj.schedule(%freq*20, hidenode, barBlue5);	%obj.schedule(%freq*20, hidenode, barBlue5F);
			
			///////////////////////////////////////////////////////////////////////////////////////////////
			
			case 3:				//light pattern 3

			%obj.lightPatternActive = 3;
			
			%obj.unhideNode(barRed3);	%obj.unhideNode(barRed3F);						//	R  X=X-=X=  B
			%obj.unhideNode(barBlue2);	%obj.unhideNode(barBlue2F);
			%obj.schedule(%freq*3, hidenode, barRed3);		%obj.schedule(%freq*3, hidenode, barRed3F);
			%obj.schedule(%freq*3, hidenode, barBlue2);		%obj.schedule(%freq*3, hidenode, barBlue2F);
			%obj.schedule(%freq*3, unhidenode, barRed0);
			%obj.schedule(%freq*3, unhidenode, barBlue0);
			%obj.schedule(%freq*6, hidenode, barRed0);
			%obj.schedule(%freq*6, hidenode, barBlue0);
			%obj.schedule(%freq*6, unhidenode, barRed3);	%obj.schedule(%freq*6, unhidenode, barRed3F);
			%obj.schedule(%freq*6, unhidenode, barBlue2);	%obj.schedule(%freq*6, unhidenode, barBlue2F);
			%obj.schedule(%freq*10, hidenode, barRed3);		%obj.schedule(%freq*10, hidenode, barRed3F);
			%obj.schedule(%freq*10, hidenode, barBlue2);	%obj.schedule(%freq*10, hidenode, barBlue2F);

			%obj.schedule(%freq*10, unhidenode, barRed2);	%obj.schedule(%freq*10, unhidenode, barRed2F);	//	R  =X=-X=X  B
			%obj.schedule(%freq*10, unhidenode, barBlue3);	%obj.schedule(%freq*10, unhidenode, barBlue3F);
			%obj.schedule(%freq*13, hidenode, barRed2);		%obj.schedule(%freq*13, hidenode, barRed2F);
			%obj.schedule(%freq*13, hidenode, barBlue3);	%obj.schedule(%freq*13, hidenode, barBlue3F);
			%obj.schedule(%freq*13, unhidenode, barRed0);
			%obj.schedule(%freq*13, unhidenode, barBlue0);
			%obj.schedule(%freq*16, hidenode, barRed0);
			%obj.schedule(%freq*16, hidenode, barBlue0);
			%obj.schedule(%freq*16, unhidenode, barRed2);	%obj.schedule(%freq*16, unhidenode, barRed2F);
			%obj.schedule(%freq*16, unhidenode, barBlue3);	%obj.schedule(%freq*16, unhidenode, barBlue3F);
			%obj.schedule(%freq*20, hidenode, barRed2);		%obj.schedule(%freq*20, hidenode, barRed2F);
			%obj.schedule(%freq*20, hidenode, barBlue3);	%obj.schedule(%freq*20, hidenode, barBlue3F);
			///////////////////////////////////////////////////////////////////////////////////////////////
		}	//End of switch
		
		
		
		if(%count > 1)	//Time to schedule more lights. We'll be back here soon if lightPatternActive > 0.
		{
			%obj.lastSchedule = %this.schedule(%freq*20, loopLights, %obj, %pattern, %count-1, %freq);
		}
		else
		{
			switch(%pattern)
			{
				case 1:
					%obj.lastSchedule = %this.schedule(%freq*20, loopLights, %obj, 2, 4, %freq);
				case 2:
					%obj.lastSchedule = %this.schedule(%freq*20, loopLights, %obj, 3, 6, %freq);
				case 3:
					%obj.lastSchedule = %this.schedule(%freq*20, loopLights, %obj, 1, 6, %freq);
			}
		}
		
		
		
	}	//End of function loopLights
};	//End of package

activatePackage(CVPI_loopLights);