datablock ShapeBaseImageData(CrownVicHL1)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 4;
   rotation = "1 0 0 -90";

	lighttype="constantlight";
	lightcolor="1 1 1";
	lightradius=25;

	stateName[0] = "Ready";

};

datablock ShapeBaseImageData(CrownVicHL2 : CrownVicHL1)
{
	mountPoint = 5;
	lightradius=75;
};



package CrownVictoriaHeadlights
{
	function serverCmdLight(%client)
	{
		if(isObject(%pl = %client.player) && !isObject(%pl.light) && isObject(%veh = %pl.getObjectMount()))
		{
			if(%veh.getDataBlock().getName() $= "CrownVictoriavehicle" && %pl.getMountNode() == 0)
			{
				servercmdCrownVicLight(%client);
				return;
			}
		}
		parent::serverCmdLight(%client);
	}
	
	function servercmdCrownVicLight(%client)
	{
		//Before we do anything, make sure the client isn't trying to change the light too rapidly.
		if(getSimTime() < %client.lastCVHLTime + 500)
		{
			return;	//Fewer than 500 milliseconds have passed since client sent a command. Ignore this one.
		}
		//If the above check did not activate, we're good to continue.
		%client.lastCVHLTime = getSimTime();	//Right now is when they sent the last command.	
		
		if(!isObject(%pl = %client.player) || !isObject(%veh = %pl.getObjectMount())) return;
		if(%veh.getDataBlock().getName() !$= "CrownVictoriavehicle" || %pl.getMountNode() != 0) return;
		
		if(!%veh.headlight)
		{
			%veh.headlight = 1;
			%veh.unhidenode(headlightindicator);
			%veh.mountImage(CrownVicHL1, 0);
			%veh.mountImage(CrownVicHL2, 1);
			%veh.unhidenode(headlight1F);
		}
		else
		{
			%veh.headlight = 0;
			%veh.hidenode(headlightindicator);
			%veh.unMountImage(0);
			%veh.unMountImage(1);
			%veh.hidenode(headlight1F);
		}
	}
	
	
	function armor::onUnMount(%this, %obj, %col, %slot)
	{
		Parent::onUnMount(%this, %obj, %col, %slot);

		if (!isObject(%col) || %obj.getMountNode() != 0 || %col.getDatablock().getName() !$= "CrownVictoriavehicle")
			return;

		%col.headlight = 0;
		%col.hidenode(headlightindicator);
		%col.unMountImage(0);
		%col.unMountImage(1);
		%col.hidenode(headlight1F);
	}
};
activatepackage(CrownVictoriaHeadlights);