datablock ParticleData(CV_TireParticle)
{
  dragCoefficient = 99;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 3000;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = 0;
  spinRandomMax = 0;
  colors[0] = "0.1 0.1 0.1 0.1";
  colors[1] = "0.1 0.1 0.1 0";
  sizes[0] = 0.75;
  useInvAlpha = true;
};

datablock ParticleEmitterData(CV_TireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 10;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "CV_TireParticle";
  useEmitterColors = true;
};

/////////////////////SPRING///////////////////////////


datablock WheeledVehicleSpring(CrownVictoriaSpring)
{
	length = 0.35;
	force = 2500;
	damping = 750;
	antiSwayForce = 0;
};

 /////////////////////////////////////////////////////
///////////////////////TIRE//////////////////////////

datablock WheeledVehicleTire(CrownVictoriaTire)
{
	shapeFile = "./shapes/CrownVictoriatire.dts";
	
	mass = 10;
	radius = 1;
	staticFriction = 3;
	kineticFriction = 3;
	restitution = 0.5;	

	lateralForce = 3000;
	lateralDamping = 4000;
	lateralRelaxation = 0.01;

	longitudinalForce = 14000;
	longitudinalDamping = 1400;
	longitudinalRelaxation = 0.01;
};

  ////////////////////////////////////////////////////
 ////////////////////////////////////////////////////
//////////////////////VEHICLE///////////////////////

datablock WheeledVehicleData(CrownVictoriaVehicle)
{
	category = "Vehicles";
	uiName = "Crown Victoria";

	handsOnVehicle = 1;
	driverLightsCompatible = 1;

	displayName = "";
	shapeFile = "./shapes/CrownVictoria.dts";
	emap = true;
	minMountDist = 3;

	massCenter = "0 0.4 0.8";

	engineTorque = 3800;
	engineBrake = 1000;
	brakeTorque = 3500;
	maxWheelSpeed = 55;

	rollForce = 0;
	yawForce = 0;
	pitchForce = 0;
	rotationalDrag = 0;

	rideable = true;
	lookUpLimit = 0.5;
	lookDownLimit = 0.5;
 
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

	paintable = true;

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.85;
	integration = 4;
	tireEmitter = CV_TireEmitter;

	cameraRoll = false;
	cameraMaxDist = 10;
	cameraOffset = 5;
	cameraTilt = 0.25;

	cameraLag = 0.0;
	cameraDecay = 0.75;
	collisionTol = 0.1;
	contactTol = 0.1;

	useEyePoint = false;	

	defaultTire = CrownVictoriaTire;
	defaultSpring = CrownVictoriaSpring;

	numWheels = 4;

	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;
	softImpactSpeed = 10;
	hardImpactSpeed = 15;
	groundImpactMinSpeed = 10.0;

	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.05;
	steeringAutoReturnMaxSpeed = 0.1;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.05;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
   
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;



	initialExplosionProjectile = CrownVictoriaExplosionProjectile;
	initialExplosionOffset = 0;

	burnTime = 4000;

	finalExplosionProjectile = CrownVictoriaFinalExplosionProjectile;
	finalExplosionOffset = 0.5;



	minRunOverSpeed    = 4;
	runOverDamageScale = 8;
	runOverPushScale   = 1.2;

	protectPassengersBurn   = false;
	protectPassengersRadius = true;
	protectPassengersDirect = false;
};